EDIT - bug #7531

PermissionDeniedException on flushing registration with modified status even if the user has the
required authority
Description

User with the Grantedauthority REGISTRATION(PREPARATION).[UPDATE]{06649467-7c4f-4b8b-98e6-395e4d3af240} changes
the status of the Registration (uuid=06649467-7c4f-4b8b-98e6-395e4d3af240) from PREPARATION to CURATION. Saving the
moidifcation to the storage fails with a PermissionDeniedException.

This happens because the RegistrationVoter only sees the updates RegistrationStatus not the old one.

Potential solution:

1)
The parameters Obiject[] previousState, String[] propertyNames available in the interceptor methods
(CdmSecurityHibernatelnterceptor) these must also be passed to PermissionVoters in general, particularity to the

furtherVotingDecission() method.
e This makes the authorization implementation more complex but would also offer more degrees of freedom.

2)

The Submitter is granted with REGISTRATION(PREPARATION,CURATION).[UPDATE]{06649467-7c4f-4b8b-98e6-395e4d3af240}.
¢ The Submitter would be enabled to save the state transition PREPARATION -> CURATION.
e Drawback: But this brings the drawback that the user would be able to modify the registration when it passed to the curation, be

e.g adding typeDesignations. This problem could be avoided by revoking this permission when the status changes by e.g. the
GrantedAuthorityRevokingRegistrationUpdateLister (see #7148)

3)
The Submitter is granted with REGISTRATION.[UPDATE]{06649467-7c4f-4b8b-98e6-395e4d3af240}.
¢ Drawback: But this brings the drawback that the user would be able to modifiy registrations in any status This problem must be

reliably avoided by revoking this permission when the status changes by e.g. the
GrantedAuthorityRevokingRegistrationUpdateLister (see #7148)

4)
The RegistrationStatus change is performed by special service bean which does it on behalf of the user. The submitter would trigger
sending a event to this service bean to request for the status change. The service bean in turn checks the permissions of the

requester and would then execute the status change in a runAs environment as SYSTEM_USER.

¢ Drawback: The updated by would not mention the submitter.

Related issues:
Related to EDIT - bug #7528: Allow changing the Registration status in the Re... Closed
Related to EDIT - feature request #7148: GrantedAuthorityRevokingRegistration... Closed

Associated revisions
https://dev.e-taxonomy.eu/redmine/issues/7148
https://dev.e-taxonomy.eu/redmine/issues/7148

Revision 72ce5cal - 07/06/2018 01:27 PM - Andreas Kohlbecker

ref #7531 intoducing TargetEntityStates to replace plain cdm enities in the permission voting process

Revision 56e9117¢c - 07/06/2018 02:28 PM - Andreas Kohlbecker

ref #7531 RegistrationVoter evaluates previous state on Registration.status changes

Revision 8f51ee96 - 07/06/2018 03:10 PM - Andreas Kohlbecker

ref #7531 CdmPermissionEvaluator.hasPermission() wraps cdm entities in TargetEntityStates

History

#1 - 07/04/2018 03:15 PM - Andreas Kohlbecker
- Related to bug #7528: Allow changing the Registration status in the RegistrationWorkingsetEditor added

#2 - 07/05/2018 11:53 AM - Andreas Kohlbecker

- Status changed from New to In Progress

#3 - 07/05/2018 02:12 PM - Andreas Kohlbecker
- Description updated

#4 - 07/05/2018 02:14 PM - Andreas Kohlbecker
- Description updated

Solution 1) still looks like the best option we have.

#5 - 07/05/2018 02:14 PM - Andreas Kohlbecker

- Related to feature request #7148: GrantedAuthorityRevokingRegistrationUpdateLister: delete orphan references to GrantedAuthoritylmpl in User and
Group added

#6 - 07/05/2018 02:22 PM - Andreas Kohlbecker

- Description updated

#7 - 07/06/2018 03:17 PM - Andreas Kohlbecker

- Status changed from In Progress to Resolved

- Assignee changed from Andreas Kohlbecker to Andreas Mtiller
- % Done changed from 0 to 50

Fixed by implementing solution 1)

@Andreas Mller: can you please review the changes in cdmlib?
#8 - 08/17/2018 09:27 AM - Andreas Miiller

- Status changed from Resolved to Closed

- Assignee changed from Andreas Mtiller to Andreas Kohlbecker

Very beautiful code ;-), | think we can close this ticket.
